// RC5 USB Mini Keyboard Adam Tatuś
#include <IRremote.h>

//definicja przyporzadkowan kodow RC5
#define IR_KEY_UP_ARROW         0x020
#define IR_KEY_DOWN_ARROW       0x021
#define IR_KEY_RETURN           0x022
#define IR_KEY_LEFT_ARROW       0x011
#define IR_KEY_RIGHT_ARROW      0x010
#define IR_KEY_ESC              0x039

int KBDelay = 200;
int RECV_PIN = 11;
int RC5_FLAG = 0;

IRrecv irrecv(RECV_PIN);
decode_results results;

void setup()
{
  irrecv.enableIRIn(); // Start the receiver
}

void RC5_Check(decode_results *results) {
  if (results->decode_type == RC5)   {
    RC5_FLAG=1;
  }
  else  {
    RC5_FLAG=0;
  }  
}

void ir_receive()
{
  if (irrecv.decode(&results)) {
    results.value= results.value & 0x0FF;
    if (RC5_FLAG == 1){
      switch (results.value) {
      case IR_KEY_UP_ARROW: 
        {
          Keyboard.press(KEY_UP_ARROW);
          delay(KBDelay);
          Keyboard.release(KEY_UP_ARROW);
          break;
        }
      case IR_KEY_DOWN_ARROW:
        {
          Keyboard.press(KEY_DOWN_ARROW);
          delay(KBDelay);
          Keyboard.release(KEY_DOWN_ARROW);
          break;
        }
      case IR_KEY_RETURN:  
        {
          Keyboard.press(KEY_RETURN);
          delay(KBDelay);
          Keyboard.release(KEY_RETURN);
          break;
        }
      case IR_KEY_LEFT_ARROW:  
        {
          Keyboard.press(KEY_LEFT_ARROW);
          delay(KBDelay);
          Keyboard.release(KEY_LEFT_ARROW);
          break;
        }     
      case IR_KEY_RIGHT_ARROW:  
        {
          Keyboard.press(KEY_RIGHT_ARROW);
          delay(KBDelay);
          Keyboard.release(KEY_RIGHT_ARROW);
          break;
        }        
      case IR_KEY_ESC:  
      {
          Keyboard.press(KEY_ESC);
          delay(KBDelay);
          Keyboard.release(KEY_ESC);
          break;
        }
      }
    }
    RC5_Check(&results);
    irrecv.resume();  
  }
}

void loop() {
  ir_receive();
  delay(250);  
}







